                                          //para acelerometro
import edu.uic.ketai.inputService.*; 
                                            //para bloquear landscape:
import android.content.res.Configuration;
                                            //ademas hay que aÃ±adir esto al AndroidManifest.xml
                                            //  <activity android:name="Skecth name" android:screenOrientation="landscape" android:configChanges="orientation|keyboardHidden">
                                      //para desactivar salvapantalla
import android.os.Bundle;
import android.view.WindowManager;

PFont font; KetaiSensorManager sensorManager; PVector accelerometer;
float x, y, z; float smoothx, smoothy, smoothz;

int walkFrame = 0; int spitFrame = 0; int counter = 0; int salto = 0;
int backx = 0; 
int achiX; 
int achiY; 
int achi_X = -70; 
int achi_Y = -50;
int velY = 0;

int fRate = 18; int fBallX = 150;

PImage [] achicorre; PImage [] achisalta;

PImage backg; PImage backg2; PImage fBall; PImage fBall2;

boolean walking = true; boolean fireball = false; boolean fireball2 = false;

void keyPressed() {
  if (key == CODED) {
  if (keyCode == DPAD) {
    // user pressed the center button on the d-pad
  } else if (keyCode == UP) {
    // user triggered 'up' on the d-pad
  } else if (keyCode == DOWN) {
    // user triggered 'down' on the d-pad
  } else if (keyCode == LEFT) {
    // user triggered 'left' on the d-pad
  } else if (keyCode == RIGHT) {
    // user triggered 'right' on the d-pad
    }
  }
  // doing other things here, and then:
  if (key == CODED && keyCode == KeyEvent.KEYCODE_BACK) {
    keyCode = 0;  // don't quit by default
  }
}

void setup() {
  size(screenWidth, screenHeight, A2D);
  String[] fonts = PFont.list();
  font = createFont(fonts[0], 18);
  textFont(font, 18);
  
  sensorManager = new KetaiSensorManager(this);
  sensorManager.start(); 
  accelerometer = new PVector();
  achicorre = new PImage[12];
  for (int i = 0; i < achicorre.length; i++) {
    achicorre[i] = loadImage("achicorre_"+ (i+1) + ".png");
  }
  achisalta = new PImage[25];
  for (int i = 0; i < achisalta.length; i++) {
    achisalta[i] = loadImage("achisalta_"+ (i+1) + ".png");
  }
  backg = loadImage("MarioTheme2.png");
  //backg2 = loadImage("MarioTheme2.png");
  fBall = loadImage("Fireball.png");
  fBall2 = loadImage("Fireball.png");
  frameRate(fRate);
}

void draw() {

  image(backg, backx, 0,  screenWidth, screenHeight);
  image(backg, backx + screenWidth, 0, screenWidth, screenHeight);
  noFill();
  
  walk();
  
  achiX = (int(screenWidth)/2 + int(150*accelerometer.y)-salto);
  achiY = int(screenHeight)-(int(screenHeight*0.125))-velY;
  //rect(0,0,achiX, achiY);
  fill(255);
  
  //shot();
  text(" x: "+achiX+ " y: "+achiY+ " velY: "+velY+"\n "+nf(frameRate, 2, 2) + "fps ("+int(screenWidth)+"x"+int(screenHeight)+")"+"\n salto: "+salto+"\n counter: "+counter, 10, 60); 
  backx-=12;
  if (backx <-screenWidth) {
    backx = 0;
  }
}

void walk(){
  velY = velY-10;
  if (velY < 0){
    velY=0;
  }
  if (walkFrame > 11) walkFrame = 0;
  if (spitFrame >24) spitFrame = 0;
  if (achiX > int(screenWidth)){
    achiX = int(screenWidth);
  }
  if (achiX < 0){
    achiX = 0;
  }
  if (walking == true) { //Walk and Jump actions
    pushMatrix();
    translate(achi_X, achi_Y);
    image(achicorre[walkFrame], achiX ,achiY);
    popMatrix();
    walkFrame++;
  } 
  if (walking == false) {
    if (achiY <= (int(screenHeight) - int(screenHeight*0.125))){ 
      if ((counter > 0) && (counter < 5)) {
        salto = salto + 12;
        //velY = 50*counter-60;
      }
      if ((counter > 5) && (counter < 10)){
        velY = 30*(counter-5);
      }
    }
    achiY = achiY - velY;
    if (counter > 5){
      salto = salto -3;
    }
    if (salto < 0) {
      salto = 0;
    }
    pushMatrix();
    translate(achi_X, achi_Y);
    image(achisalta[spitFrame], achiX, achiY);
    popMatrix();
    spitFrame++;
    counter++;
    if (counter > 24) {
    counter = 0;
    walking = true;
    }
  }
}

void shot(){
  if (fireball == true) { //Fireball action
    //fBallX = 150;
    image(fBall, fBallX, 375 + 5, 15, 15);
    fBallX += 10;
    if (fBallX >= screenWidth) {
      fireball = false;
      fBallX += 0;
    }
  }
}
                                       // para detectar touch
public boolean surfaceTouchEvent(MotionEvent event) {
  // your code here
  // if you want the variables for motionX/motionY, mouseX/mouseY etc.
  // to work properly, you'll need to call super.surfaceTouchEvent().
  walking = false;
  if (fireball == false) fireball = true;
  if(fireball == true) fireball2 = true;
  fBallX = 150;
  return super.surfaceTouchEvent(event);
}                                       
                                       //para desactivar salvapantalla
void onCreate(Bundle bundle) {
  super.onCreate(bundle);
  getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
}
                                        //bloquer landscape
public void onConfigurationChanged(Configuration newConfig) {
   super.onConfigurationChanged(newConfig);
 }
 
void onAccelerometerSensorEvent(long time, int accuracy, float x, float y, float z) {
  smoothx += 0.1 * (x - smoothx);
  smoothy += 0.1 * (y - smoothy);
  smoothz += 0.1 * (z - smoothz);
  accelerometer.set(smoothx, smoothy, smoothz);
}
